
Foreman - Bug #2285

Validation doesn't prevent "invalid address" error when creating subnets

03/06/2013 06:18 AM - Joost Ringoot

Status: Closed   

Priority: Normal   

Assignee: Joseph Magen   

Category: Web Interface   

Target version: 1.2.0   

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases:  

Bugzilla link:  Red Hat JIRA:  

Pull request:    

Description

When adding a subnet in the provisiong and having accidently a whitespace in front of the Network: eg " 192.168.16.0" instead of

"192.168.16.0" I get this error:

Oops, we're sorry but something went wrong

x invalid address

If you feel this is an error with Foreman itself, please open a new issue with Foreman ticketing system, You would probably need to

attach the Full trace and relevant log entries.

Back

ArgumentError

invalid address

app/models/subnet.rb:72:in `new'

app/models/subnet.rb:72:in `cidr'

app/models/subnet.rb:38:in `to_label'

app/views/subnets/index.html.erb:17:in `_app_views_subnets_index_html_erb___1480953890_70168276658080_0'

app/views/subnets/index.html.erb:14:in `_app_views_subnets_index_html_erb___1480953890_70168276658080_0'

lib/foreman/thread_session.rb:31:in `clear_thread'

It appears when doing this for the first subnet.

I can add other subnets but I can not modify them, since this page shows where I would expect to see the already defined subnets

Associated revisions

Revision 31aa5db5 - 06/05/2013 04:43 AM - Joseph Magen

fixes #2285 - subnet validation - length of addresses, strip whitespace and fix common typos

Revision 3d0287be - 06/05/2013 04:46 AM - Joseph Magen

fixes #2285 - subnet validation - length of addresses, strip whitespace and fix common typos

(cherry picked from commit 31aa5db511a6decf800e68a2b6f6eb3dbf0ae29c)

History

#1 - 03/06/2013 06:20 AM - Dominic Cleal

- Subject changed from problem with creating subnets to Validation doesn't prevent "invalid address" error when creating subnets

- Category set to Web Interface

There are validators for the various IP addresses, but it looks like they won't prevent execution of the IPAddr.new calls, which then throw exceptions

with invalid IPs.

#2 - 03/27/2013 06:47 AM - Alex Rodenberg

I accidentally had put in 2555.255.255.0 and same thing happened to me.. any way for me to delete this entry so I have a functional subnet menu

again ?
#3 - 03/27/2013 07:16 AM - Alex Rodenberg

UPDATE subnets SET mask = "255.255.255.0" WHERE mask = "2555.255.255.0";

fixed it.

I guess the regex used does not catch what it's supposed to.

From subnet.rb:

validates_format_of     :network, :mask,                        :with => Net::Validations::IP_REGEXP

#4 - 05/23/2013 06:59 AM - Dominic Cleal

- Target version set to 1.2.0

#5 - 06/04/2013 08:12 AM - Joseph Magen

- Status changed from New to Assigned

- Assignee set to Joseph Magen

#6 - 06/04/2013 02:39 PM - Dominic Cleal

- Status changed from Assigned to Ready For Testing

https://github.com/theforeman/foreman/pull/687

Also raised here: https://bugzilla.redhat.com/show_bug.cgi?id=970743

#7 - 06/05/2013 04:46 AM - Joseph Magen

Joost, I assume that the reason that you can create, but not edit, subnets is because of your role/permissions defined in foreman.

#8 - 06/05/2013 04:49 AM - Dominic Cleal

Joseph Magen wrote:

Joost, I assume that the reason that you can create, but not edit, subnets is because of your role/permissions defined in foreman.

 I think it's simply the exception being thrown breaking the UI.  If you created an invalid subnet, the index page wouldn't be displayed as the to_label

would throw exceptions from IPAddr.new when rendering the CIDR notation.

#9 - 06/05/2013 05:17 AM - Joseph Magen

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset 3d0287be8aa8dcc930431fbaf1a7514fc5dc7f52.
